#include <vector>
#include <valarray>
#include <istream>
#include <string>
#include <sstream>
#include "ply.h"

void read_ply(std::istream &in,
              std::vector<std::valarray<float> > &vertices,
              std::vector<std::valarray<int> > &faces)
{
    std::string line;
    int nv, nf;

    while (std::getline(in, line))
    {
        std::string token;
        std::istringstream s(line);

        s >> token;
        if (token == "element")
        {
            s >> token;
            if (token == "vertex")
                s >> nv;
            else if (token == "face")
                s >> nf;
            else
                abort();
        }
        else if (token == "end_header") break;
    }

    vertices.resize(nv);
    for (int i = 0; i < nv; i++)
    {
        std::getline(in, line);
        std::istringstream s(line);

        vertices[i].resize(3);
        s >> vertices[i][0] >> vertices[i][1] >> vertices[i][2];
    }

    faces.resize(nf);
    for (int i = 0; i < nf; i++)
    {
        std::getline(in, line);
        std::istringstream s(line);
        int c;

        s >> c;
        faces[i].resize(c);
        for (int j = 0; j < c; j++)
            s >> faces[i][j];
    }
}
