#include <iostream>
#include <sstream>
#include <vector>
#include <cstdlib>
#include "arith.h"

using namespace std;

static void generate(vector<int> &V, int n, int mx)
{
    for (int i = 0; i < n; i++)
        V.push_back(rand() % mx + 10);
}

int main()
{
    int n = 1000000;
    int mx = 1000;
    vector<int> input;
    vector<int> output;
    stringstream s;
    context cfq, dfq;
    compressor c;

    generate(input, n, mx);
    c.open(s);
    cfq.code_range(10, mx + 9);
    for (int i = 0; i < n; i++) c.encode(cfq, input[i]);
    c.close();

    decompressor d(s);
    dfq.code_range(10, mx + 9);
    for (int i = 0; i < n; i++) output.push_back(d.decode(dfq));

    if (input != output)
    {
        cerr << "Mismatch\n";
        return 1;
    }
    return 0;
}
